using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Management;
using System.Net;

namespace M3ServerMonitor
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
    protected System.Web.UI.WebControls.DataGrid DataGrid1;
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.HtmlControls.HtmlGenericControl divExport;
    protected System.Web.UI.WebControls.Button cmdGetPerformance;
		
  
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.cmdGetPerformance.Click += new System.EventHandler(this.cmdGetPerformance_Click);
			this.Button1.Click += new System.EventHandler(this.Button1_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

    private void cmdGetPerformance_Click(object sender, System.EventArgs e)
    {
      ManagementScope Scope = null;
			
      try
      {
        Scope = new ManagementScope(@"\\" + Dns.GetHostName() + @"\root\Mobiltec\M3Server");
        Scope.Connect();
      }
      catch (Exception)
      {
        return;
      }

      ManagementClass WMIClass = null;
			
      try
      {
        //associa a classe registrada no WMI
        ManagementPath mPath = new ManagementPath();
        mPath.RelativePath = "SyncPerformance";
        WMIClass = new ManagementClass(Scope, mPath, null);

        DataTable tabPerfData = new DataTable();
        tabPerfData.Columns.Add("Identificador");
		tabPerfData.Columns.Add("Incio");
		tabPerfData.Columns.Add("Fim");
        tabPerfData.Columns.Add("Tempo(seg)");

        


		  //A consulta a ser executada
		  WqlObjectQuery Query = new WqlObjectQuery("SELECT * FROM SyncPerformance");

		 //Instanci o "buscador" passando o escopo (mesmo da figura 5.x) e a consulta
		 ManagementObjectSearcher Searcher = new ManagementObjectSearcher(Scope, Query);

         //Executa a consulta
		 ManagementObjectCollection mngColl = Searcher.Get();

		long soma = 0;
		  //busca todas as instancias
        foreach (ManagementObject mngObj in mngColl)
        {
          	PropertyData devId = mngObj.Properties["DevId"];
			PropertyData beginTime = mngObj.Properties["SyncBeginTime"];
			PropertyData endTime = mngObj.Properties["SyncEndTime"];
			PropertyData syncTime = mngObj.Properties["SpentTime"];

			int intDevId = Convert.ToInt32(devId.Value);
			DateTime dtBegin = Convert.ToDateTime(beginTime.Value);
			DateTime dtEnd = Convert.ToDateTime(endTime.Value);
          	float lngSyncTime = ((float)Convert.ToInt64(syncTime.Value))/((float)1000);

			soma += Convert.ToInt64(syncTime.Value);
			

          object[] param = {intDevId,dtBegin,dtEnd,lngSyncTime};

          tabPerfData.Rows.Add(param);

          mngObj.Dispose();
        }

		  DataView dv = new DataView(tabPerfData);
        DataGrid1.DataSource = dv;
		  dv.Sort = "Tempo(seg) ASC";

		  long mdia = soma/tabPerfData.Rows.Count;
        DataGrid1.DataBind();

		  
      }
      finally
      {
        //libera os recursos
        if (WMIClass != null)
          WMIClass.Dispose();
      }
    
      
    }

		private void Button1_Click(object sender, System.EventArgs e)
		{
			this.ExportToExcel(divExport, (DataGrid1.Items.Count > 0));
		}

		/// <summary>
		/// Export data within the datagrid to an excel file. 
		/// </summary>
		/// <param name="mGrid">Datagrid containing data to be printed.</param>
		protected void ExportToExcel(DataGrid mGrid)
		{
			if (mGrid.Items.Count == 0)
			{
				Response.Write("<script>alert('No results to export.');</script>");
				//Prevents open a new page in the history every time the alert is fired.
				//Thus, when an alert is fired, it backs to the calling page. 
				Response.Write("<script>history.go(-1);</script>");
				return;
			}
      
			Response.Clear();
			Response.Buffer= false;
			Response.ContentType = "application/vnd.ms-excel";
			Response.Charset = "";
			this.EnableViewState = false;

			try
			{
				WriteHtmlHeader();		        		    
				System.IO.StringWriter lStringWriter = new System.IO.StringWriter();
				System.Web.UI.HtmlTextWriter lHtmlTextWriter = new System.Web.UI.HtmlTextWriter(lStringWriter);
				Response.Write("<BR>");
				Response.Write ("Report Name: " /*+ this.pReportName*/);
				Response.Write("<BR>");
				Response.Write ("Print date: " + DateTime.Now.ToShortDateString());
				Response.Write("<BR>");
				Response.Write("<BR>");

				mGrid.RenderControl(lHtmlTextWriter);
        
				Response.Write(lStringWriter.ToString());
				WriteHtmlFoot();
			}
			catch(Exception)
			{
				Response.Write("Error while exporting to excel.");
			}

			Response.End();
		}

		// <summary>
		/// Writes the HTML header
		/// </summary>
		void WriteHtmlHeader()
		{
			Response.Write("<html>\n");
			Response.Write("<style>\n <!--");
			System.IO.StreamReader lStreamReader = new System.IO.StreamReader(Server.MapPath("styles/style.css"));
			Response.Write(lStreamReader.ReadToEnd());
			lStreamReader.Close();
			Response.Write("\n //--> \n </style>");
			Response.Write("<body>\n");                              
		}

		/// <summary>
		/// Writes the HTML foot
		/// </summary>
		void WriteHtmlFoot()
		{
			Response.Write("\n</body>");
			Response.Write("\n</html>");      
		}

		/// <summary>
		/// Export data to an excel file. 
		/// </summary>
		/// <param name="mHtmlComponent">HTMLGeneric Control containing the data</param>
		/// <param name="mHasContent">if the report returns data or not</param>
		protected void ExportToExcel(HtmlControl mHtmlComponent, bool mHasContent)
		{
			if (mHasContent)
			{
				Response.Clear();
				Response.Buffer= false;
				Response.ContentType = "application/vnd.ms-excel";
				Response.Charset = "";
				this.EnableViewState = false;

				try
				{
					WriteHtmlHeader();          					
					System.IO.StringWriter lStringWriter = new System.IO.StringWriter();
					System.Web.UI.HtmlTextWriter lHtmlTextWriter = new System.Web.UI.HtmlTextWriter(lStringWriter);
					mHtmlComponent.RenderControl(lHtmlTextWriter);
				
					Response.Write(lStringWriter.ToString());
					WriteHtmlFoot();
				}
				catch(Exception)
				{
					Response.Write("Error while exporting to excel.");
				}

				Response.End();
			}
			else
			{
				Response.Write("<script>alert('" + "TESTE" + "');</script>");
				//Prevents open a new page in the history every time the alert is fired.
				//Thus, when an alert is fired, it backs to the calling page. 
				Response.Write("<script>history.go(-1);</script>");
				return;
			}
		}
	}
}
